Leetcode 1705. 吃苹果的最大数目(medium)

2023-12-29 15:18

本文主要是介绍Leetcode 1705. 吃苹果的最大数目(medium),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

题目

有一棵特殊的苹果树,一连 n 天,每天都可以长出若干个苹果。在第 i 天,树上会长出 apples[i] 个苹果,这些苹果将会在 days[i] 天后(也就是说,第 i + days[i] 天时)腐烂,变得无法食用。也可能有那么几天,树上不会长出新的苹果,此时用 apples[i] == 0 且 days[i] == 0 表示。

你打算每天 最多 吃一个苹果来保证营养均衡。注意,你可以在这 n 天之后继续吃苹果。

给你两个长度为 n 的整数数组 days 和 apples ,返回你可以吃掉的苹果的最大数目。

示例 1:

输入:apples = [1,2,3,5,2], days = [3,2,1,4,2]
输出:7
解释:你可以吃掉 7 个苹果:
- 第一天,你吃掉第一天长出来的苹果。
- 第二天,你吃掉一个第二天长出来的苹果。
- 第三天,你吃掉一个第二天长出来的苹果。过了这一天,第三天长出来的苹果就已经腐烂了。
- 第四天到第七天,你吃的都是第四天长出来的苹果。
示例 2:

输入:apples = [3,0,0,0,0,2], days = [3,0,0,0,0,2]
输出:5
解释:你可以吃掉 5 个苹果:
- 第一天到第三天,你吃的都是第一天长出来的苹果。
- 第四天和第五天不吃苹果。
- 第六天和第七天,你吃的都是第六天长出来的苹果。

来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/maximum-number-of-eaten-apples
著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。

解题思路

1. 原始解法

使用一个列表food来存储信息,列表的每个元素是[i + days[i], apples[i]]

前n天:

        (1). 收获苹果:当某一天的apples[i]不为0时,才向food添加元素

food = []
for i in range(n):  # at day i, we first harvest applesif apples[i] != 0:food.append([i + days[i], apples[i]])

        (2).对food进行排序,依据为i + days[i]:排序是为了吃最快腐烂的苹果

# then we need to sort the list based on i+days[i]
food.sort(key=lambda x: x[0])

        (3).如果有苹果,则吃一个

# now we have to find out whether we have an apple to eat
if len(food) != 0:food[0][1] -= 1count += 1

        (4).丢弃所有将要腐烂的苹果(以及被吃完的food[0])

# if we ate all apples from food[0], drop it
if len(food) != 0:if food[0][1] == 0:food.pop(0)# at the end of day, we need to throw away all rotten apples
if len(food) != 0:while (food[0][0] == i + 1):food.pop(0)if len(food) == 0:break

后续:

        每一天吃一个苹果,并丢弃过期的。这里我使用了for循环,所以需要先确定最后一批苹果腐烂的那一天。如果前n天吃掉了所有水果,则无需处理后续部分。

# max_day represents the last day we have an apple
if len(food) > 0:max_day = food[-1][0]
else:max_day = n

        吃苹果、丢苹果与前n天类似

结果:通过66/69测试用例,之后超时。原因应该是排序的部分。

完整代码:

class Solution:def eatenApples(self, apples: List[int], days: List[int]) -> int:count = 0n = len(apples)# use a list to store all the information# each element of the list has two components  [i+days[i], apples[i]]        food = []for i in range(n): # at day i, we first harvest applesif apples[i] != 0:food.append([i + days[i], apples[i]])# then we need to sort the list based on i+days[i]food.sort(key=lambda x: x[0])# now we have to find out whether we have an apple to eatif len(food) != 0:food[0][1] -= 1count += 1# if we ate all apples from food[0], drop itif len(food) != 0:if food[0][1] == 0:food.pop(0)# at the end of day, we need to throw away all rotten applesif len(food) != 0:while (food[0][0] == i + 1):food.pop(0)if len(food) == 0:break# max_day represents the last day we have an appleif len(food) > 0:max_day = food[-1][0]else:max_day = nfor i in range(n, max_day):# if there's no appleif len(food) == 0:break# else eat an applefood[0][1] -= 1count += 1# if we ate all apples from food[0], drop itif food[0][1] == 0:food.pop(0)# at the end of day, we need to throw away all rotten applesif len(food) != 0:while (food[0][0] == i + 1):food.pop(0)if len(food) == 0:breakreturn count

2.第一次优化

使用heapq创建一个优先队列取代列表。使用queue.PriorityQueue也可以实现目的,后者只是加入了线程方面的保护,操作仍是基于heapq。

前n天:

        (1). 收获苹果

import heapq     
food = []for i in range(n): # at day i, we first harvest applesif apples[i] != 0:heapq.heappush(food, [i + days[i], apples[i]])

        (2).由于使用了heapq,此时我们无需再排序,直接判断能否吃一个苹果。此处另一个区别在于,我们将food[0]直接从队列中取出了,如果我们没有吃完food[0],需要将其再加入队列。

# now we have to find out whether we have an apple to eat
if len(food) != 0:count += 1temp = heapq.heappop(food)if temp[1] > 1:# if we haven't eaten all the apples from food[0]heapq.heappush(food, [temp[0], temp[1] - 1])

        (3).丢弃将要腐烂的苹果

# at the end of day, we need to throw away all rotten apples
while(len(food) > 0):if food[0][0] == i + 1:heapq.heappop(food)else:break

后续:

        在后续部分的处理中,由于使用了堆,导致无法通过food[-1]的方式得到最后一批苹果腐烂的时间。所以要用while循环判定是否还有苹果剩下,并用另一个变量记录日期。(也许这本身就是更好的处理方法)

# start from day n
i = n
# if there are still some apples left
while(len(food) > 0):count += 1temp = heapq.heappop(food)if temp[1] > 1:# if we haven't eaten all the apples from food[0]heapq.heappush(food, [temp[0], temp[1] - 1])# at the end of day, we need to throw away all rotten appleswhile(len(food) > 0):if food[0][0] == i + 1:heapq.heappop(food)else:breaki += 1

结果:通过全部测试用例。用时456ms,内存使用量19.3MB。

完整代码:

class Solution:def eatenApples(self, apples: List[int], days: List[int]) -> int:count = 0n = len(apples)# use a list to store all the information# each element of the list has two components  [i+days[i], apples[i]]   # use heapqimport heapq     food = []for i in range(n):# at day i, we first harvest applesif apples[i] != 0:heapq.heappush(food, [i + days[i], apples[i]])# now we have to find out whether we have an apple to eatif len(food) != 0:count += 1temp = heapq.heappop(food)if temp[1] > 1:# if we haven't eaten all the apples from food[0]heapq.heappush(food, [temp[0], temp[1] - 1])# at the end of day, we need to throw away all rotten appleswhile(len(food) > 0):if food[0][0] == i + 1:heapq.heappop(food)else:breaki = n# if there are still some apples leftwhile(len(food) > 0):count += 1temp = heapq.heappop(food)if temp[1] > 1:# if we haven't eaten all the apples from food[0]heapq.heappush(food, [temp[0], temp[1] - 1])# at the end of day, we need to throw away all rotten appleswhile(len(food) > 0):if food[0][0] == i + 1:heapq.heappop(food)else:breaki += 1return count

3.第二次优化

通过学习题解,更改了代码的结构。主要的改动在于,不必区分前n天及之后的部分,可以使用一个while循环一并处理。

count = 0
n = len(apples)
current_day = 0# use a list to store all the information
# each element of the list has two components  [i+days[i], apples[i]]   # use heapq
import heapq     
food = []
while food or current_day < n:'''codes'''        current_day += 1

        (1). 收获苹果:只在前n天访问apples和days数组

if current_day < n:# harverst applesif apples[current_day] != 0:heapq.heappush(food, [current_day + days[current_day], apples[current_day]])

        (2). 吃苹果

if food:count += 1temp = heapq.heappop(food)if temp[1] > 1:# if we haven't eaten all the apples from food[0], then push it backheapq.heappush(food, [temp[0], temp[1] - 1])

        (3). 丢弃将要腐烂的水果

# at the end of day, we need to throw away all rotten apples
while(len(food) > 0):if food[0][0] == current_day + 1:heapq.heappop(food)else:break

结果:通过全部测试用例,用时524ms,内存使用量19.3MB

完整代码:

class Solution:def eatenApples(self, apples: List[int], days: List[int]) -> int:count = 0n = len(apples)current_day = 0# use a list to store all the information# each element of the list has two components  [i+days[i], apples[i]]   # use heapqimport heapq     food = []while food or current_day < n:# if we have apples or we can possibly harvest applesif current_day < n:# harverst applesif apples[current_day] != 0:heapq.heappush(food, [current_day + days[current_day], apples[current_day]])# then we need to find out whether we have an apple to eatif food:count += 1temp = heapq.heappop(food)if temp[1] > 1:# if we haven't eaten all the apples from food[0], then push it backheapq.heappush(food, [temp[0], temp[1] - 1])                # at the end of day, we need to throw away all rotten appleswhile(len(food) > 0):if food[0][0] == current_day + 1:heapq.heappop(food)else:breakcurrent_day += 1return count

4. 第三次优化

将food的每个元素从列表换成了元组,同时更改了一个判断语句。

更改:

        1:添加元素

heapq.heappush(food, (current_day + days[current_day], apples[current_day]))

        2. 将没吃完的food[0]推回去

d, nb = heapq.heappop(food)
if nb > 1:# if we haven't eaten all the apples from food[0], then push it backheapq.heappush(food, (d, nb - 1))

结果:通过测试用例。用时360ms,内存使用量19MB。

完整代码:

class Solution:def eatenApples(self, apples: List[int], days: List[int]) -> int:count = 0n = len(apples)current_day = 0# use a list to store all the information# each element of the list has two components  [i+days[i], apples[i]]   # use heapqimport heapq     food = []while food or current_day < n:# if we have apples or we can possibly harvest applesif current_day < n and apples[current_day] != 0:# harverst apples            heapq.heappush(food, (current_day + days[current_day], apples[current_day]))# then we need to find out whether we have an apple to eatif food:count += 1d, nb = heapq.heappop(food)if nb > 1:# if we haven't eaten all the apples from food[0], then push it backheapq.heappush(food, (d, nb - 1))# at the end of day, we need to throw away all rotten appleswhile food:if food[0][0] == current_day + 1:heapq.heappop(food)else:breakcurrent_day += 1return count

相关知识

1. 优先队列

这篇关于Leetcode 1705. 吃苹果的最大数目(medium)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/549838

相关文章

如何提高Redis服务器的最大打开文件数限制

《如何提高Redis服务器的最大打开文件数限制》文章讨论了如何提高Redis服务器的最大打开文件数限制,以支持高并发服务,本文给大家介绍的非常详细,感兴趣的朋友跟随小编一起看看吧... 目录如何提高Redis服务器的最大打开文件数限制问题诊断解决步骤1. 修改系统级别的限制2. 为Redis进程特别设置限制

哈希leetcode-1

目录 1前言 2.例题  2.1两数之和 2.2判断是否互为字符重排 2.3存在重复元素1 2.4存在重复元素2 2.5字母异位词分组 1前言 哈希表主要是适合于快速查找某个元素(O(1)) 当我们要频繁的查找某个元素,第一哈希表O(1),第二,二分O(log n) 一般可以分为语言自带的容器哈希和用数组模拟的简易哈希。 最简单的比如数组模拟字符存储,只要开26个c

hdu1496(用hash思想统计数目)

作为一个刚学hash的孩子,感觉这道题目很不错,灵活的运用的数组的下标。 解题步骤:如果用常规方法解,那么时间复杂度为O(n^4),肯定会超时,然后参考了网上的解题方法,将等式分成两个部分,a*x1^2+b*x2^2和c*x3^2+d*x4^2, 各自作为数组的下标,如果两部分相加为0,则满足等式; 代码如下: #include<iostream>#include<algorithm

poj 3723 kruscal,反边取最大生成树。

题意: 需要征募女兵N人,男兵M人。 每征募一个人需要花费10000美元,但是如果已经招募的人中有一些关系亲密的人,那么可以少花一些钱。 给出若干的男女之间的1~9999之间的亲密关系度,征募某个人的费用是10000 - (已经征募的人中和自己的亲密度的最大值)。 要求通过适当的招募顺序使得征募所有人的费用最小。 解析: 先设想无向图,在征募某个人a时,如果使用了a和b之间的关系

poj 3258 二分最小值最大

题意: 有一些石头排成一条线,第一个和最后一个不能去掉。 其余的共可以去掉m块,要使去掉后石头间距的最小值最大。 解析: 二分石头,最小值最大。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <c

poj 2175 最小费用最大流TLE

题意: 一条街上有n个大楼,坐标为xi,yi,bi个人在里面工作。 然后防空洞的坐标为pj,qj,可以容纳cj个人。 从大楼i中的人到防空洞j去避难所需的时间为 abs(xi - pi) + (yi - qi) + 1。 现在设计了一个避难计划,指定从大楼i到防空洞j避难的人数 eij。 判断如果按照原计划进行,所有人避难所用的时间总和是不是最小的。 若是,输出“OPETIMAL",若

poj 2135 有流量限制的最小费用最大流

题意: 农场里有n块地,其中约翰的家在1号地,二n号地有个很大的仓库。 农场有M条道路(双向),道路i连接着ai号地和bi号地,长度为ci。 约翰希望按照从家里出发,经过若干块地后到达仓库,然后再返回家中的顺序带朋友参观。 如果要求往返不能经过同一条路两次,求参观路线总长度的最小值。 解析: 如果只考虑去或者回的情况,问题只不过是无向图中两点之间的最短路问题。 但是现在要去要回

poj 2594 二分图最大独立集

题意: 求一张图的最大独立集,这题不同的地方在于,间接相邻的点也可以有一条边,所以用floyd来把间接相邻的边也连起来。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <cmath>#include <sta

poj 3422 有流量限制的最小费用流 反用求最大 + 拆点

题意: 给一个n*n(50 * 50) 的数字迷宫,从左上点开始走,走到右下点。 每次只能往右移一格,或者往下移一格。 每个格子,第一次到达时可以获得格子对应的数字作为奖励,再次到达则没有奖励。 问走k次这个迷宫,最大能获得多少奖励。 解析: 拆点,拿样例来说明: 3 2 1 2 3 0 2 1 1 4 2 3*3的数字迷宫,走两次最大能获得多少奖励。 将每个点拆成两个

poj 3692 二分图最大独立集

题意: 幼儿园里,有G个女生和B个男生。 他们中间有女生和女生认识,男生男生认识,也有男生和女生认识的。 现在要选出一些人,使得这里面的人都认识,问最多能选多少人。 解析: 反过来建边,将不认识的男生和女生相连,然后求一个二分图的最大独立集就行了。 下图很直观: 点击打开链接 原图: 现图: 、 代码: #pragma comment(